package com.jinhaiqimeng.sysManageMicroservice.web.vo.common;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.google.common.collect.Maps;
import com.jinhaiqimeng.sysManageMicroservice.util.SpecialReplaceUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Map;

@ApiModel(value = "列表查询基础dto")
public class BaseListDTO  implements Serializable {

    @ApiModelProperty(value = "当前页，从1开始")
    private Integer pageNum=1;
    @ApiModelProperty(value = "每页条数")
    private Integer pageSize=15;
    @ApiModelProperty(value = "开始时间 yyyy-MM-dd HH:mm:ss")
    private String startTime;
    @ApiModelProperty(value = "结束时间 yyyy-MM-dd HH:mm:ss")
    private String endTime;
    @ApiModelProperty(value = "关键字")
    private String keyword;
    @ApiModelProperty(value = "是否分页")
    private Boolean page;

    @ApiModelProperty(value = "排序参数 key:为约定排序类型 value为:asc升序 desc降序")
    private Map<String,String> sortParam;

    public BaseListDTO() {
        this.page = true;
    }

    public Integer getPageNum() {
        if(pageNum==null||pageNum==0){
            return 1;
        }
        return pageNum;
    }

    public void setPageNum(Integer pageNum) {
        this.pageNum = pageNum;
    }

    public Integer getPageSize() {
        if(pageSize==null||pageSize==0){
            return 15;
        }
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public String getKeyword() {
        if (StrUtil.isNotBlank(keyword)){
            return SpecialReplaceUtil.replace(keyword);
        }
        return keyword;
    }

    public void setKeyword(String keyword) {
        this.keyword = keyword;
    }

    public Boolean getPage() {
        return page;
    }

    public void setPage(Boolean page) {
        this.page = page;
    }

    public Map<String, String> getSortParam() {
        if (ObjectUtil.isNull(sortParam)){
            sortParam = Maps.newHashMap();
        }
        return sortParam;
    }

    public void setSortParam(Map<String, String> sortParam) {
        this.sortParam = sortParam;
    }
}
